src/Entity/Voiture.php
<?php

namespace App\Entity;

use App\Repository\VoitureRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=VoitureRepository::class)
 */
class Voiture
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $serie;

    /**
     * @ORM\Column(type="date")
     */
    private $date_mise_en_marche;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $modele;

    /**
     * @ORM\Column(type="float")
     */
    private $prix_jour;

    /**
     * @ORM\OneToMany(targetEntity=Location::class, mappedBy="voiture")
     */
    private $location;

    public function __construct()
    {
        $this->location = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getSerie(): ?string
    {
        return $this->serie;
    }

    public function setSerie(string $serie): self
    {
        $this->serie = $serie;

        return $this;
    }

    public function getDateMiseEnMarche(): ?\DateTimeInterface
    {
        return $this->date_mise_en_marche;
    }

    public function setDateMiseEnMarche(\DateTimeInterface $date_mise_en_marche): self
    {
        $this->date_mise_en_marche = $date_mise_en_marche;

        return $this;
    }

    public function getModele(): ?string
    {
        return $this->modele;
    }

    public function setModele(string $modele): self
    {
        $this->modele = $modele;

        return $this;
    }

    public function getPrixJour(): ?float
    {
        return $this->prix_jour;
    }

    public function setPrixJour(float $prix_jour): self
    {
        $this->prix_jour = $prix_jour;

        return $this;
    }

    /**
     * @return Collection<int, Location>
     */
    public function getLocation(): Collection
    {
        return $this->location;
    }

    public function addLocation(Location $location): self
    {
        if (!$this->location->contains($location)) {
            $this->location[] = $location;
            $location->setVoiture($this);
        }

        return $this;
    }

    public function removeLocation(Location $location): self
    {
        if ($this->location->removeElement($location)) {
            // set the owning side to null (unless already changed)
            if ($location->getVoiture() === $this) {
                $location->setVoiture(null);
            }
        }

        return $this;
    }
}

src/Form/VoitureType.php
<?php

namespace App\Form;

use App\Entity\Voiture;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class VoitureType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $builder
            ->add('serie')
            ->add('date_mise_en_marche')
            ->add('modele')
            ->add('prix_jour')
        ;
    }

    public function configureOptions(OptionsResolver $resolver): void
    {
        $resolver->setDefaults([
            'data_class' => Voiture::class,
        ]);
    }
}

src/Controller/VoitureController.php
<?php

namespace App\Controller;

use App\Entity\Voiture;
use App\Form\VoitureType;
use App\Repository\VoitureRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

/**
 * @Route("/voiture")
 */
class VoitureController extends AbstractController
{
    /**
     * @Route("/", name="app_voiture_index", methods={"GET"})
     */
    public function index(VoitureRepository $voitureRepository): Response
    {
        return $this->render('voiture/index.html.twig', [
            'voitures' => $voitureRepository->findAll(),
        ]);
    }

    /**
     * @Route("/new", name="app_voiture_new", methods={"GET", "POST"})
     */
    public function new(Request $request, VoitureRepository $voitureRepository): Response
    {
        $voiture = new Voiture();
        $form = $this->createForm(VoitureType::class, $voiture);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $voitureRepository->add($voiture, true);

            return $this->redirectToRoute('app_voiture_index', [], Response::HTTP_SEE_OTHER);
        }

        return $this->renderForm('voiture/new.html.twig', [
            'voiture' => $voiture,
            'form' => $form,
        ]);
    }

    /**
     * @Route("/{id}", name="app_voiture_show", methods={"GET"})
     */
    public function show(Voiture $voiture): Response
    {
        return $this->render('voiture/show.html.twig', [
            'voiture' => $voiture,
        ]);
    }

    /**
     * @Route("/{id}/edit", name="app_voiture_edit", methods={"GET", "POST"})
     */
    public function edit(Request $request, Voiture $voiture, VoitureRepository $voitureRepository): Response
    {
        $form = $this->createForm(VoitureType::class, $voiture);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $voitureRepository->add($voiture, true);

            return $this->redirectToRoute('app_voiture_index', [], Response::HTTP_SEE_OTHER);
        }

        return $this->renderForm('voiture/edit.html.twig', [
            'voiture' => $voiture,
            'form' => $form,
        ]);
    }

    /**
     * @Route("/{id}", name="app_voiture_delete", methods={"POST"})
     */
    public function delete(Request $request, Voiture $voiture, VoitureRepository $voitureRepository): Response
    {
        if ($this->isCsrfTokenValid('delete' . $voiture->getId(), $request->request->get('_token'))) {
            $voitureRepository->remove($voiture, true);
        }

        return $this->redirectToRoute('app_voiture_index', [], Response::HTTP_SEE_OTHER);
    }
}

templates/voiture/_delete_form.html.twig
<form method="post" action="{{ path('app_voiture_delete', {'id': voiture.id}) }}" onsubmit="return confirm('Are you sure you want to delete this item?');">
    <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ voiture.id) }}">
    <button class="btn">Delete</button>
</form>

templates/voiture/_form.html.twig
{{ form_start(form) }}
    {{ form_widget(form) }}
    <button class="btn">{{ button_label|default('Save') }}</button>
{{ form_end(form) }}

templates/voiture/edit.html.twig
{% extends 'base.html.twig' %}

{% block title %}Edit Voiture{% endblock %}

{% block body %}
    <h1>Edit Voiture</h1>

    {{ include('voiture/_form.html.twig', {'button_label': 'Update'}) }}

    <a href="{{ path('app_voiture_index') }}">back to list</a>

    {{ include('voiture/_delete_form.html.twig') }}
{% endblock %}

templates/voiture/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}Voiture index{% endblock %}

{% block body %}
    <h1>Voiture index</h1>

    <table class="table">
        <thead>
            <tr>
                <th>Id</th>
                <th>Serie</th>
                <th>Date_mise_en_marche</th>
                <th>Modele</th>
                <th>Prix_jour</th>
                <th>actions</th>
            </tr>
        </thead>
        <tbody>
        {% for voiture in voitures %}
            <tr>
                <td>{{ voiture.id }}</td>
                <td>{{ voiture.serie }}</td>
                <td>{{ voiture.dateMiseEnMarche ? voiture.dateMiseEnMarche|date('Y-m-d') : '' }}</td>
                <td>{{ voiture.modele }}</td>
                <td>{{ voiture.prixJour }}</td>
                <td>
                    <a href="{{ path('app_voiture_show', {'id': voiture.id}) }}">show</a>
                    <a href="{{ path('app_voiture_edit', {'id': voiture.id}) }}">edit</a>
                </td>
            </tr>
        {% else %}
            <tr>
                <td colspan="6">no records found</td>
            </tr>
        {% endfor %}
        </tbody>
    </table>

    <a href="{{ path('app_voiture_new') }}">Create new</a>
{% endblock %}

templates/voiture/new.html.twig
{% extends 'base.html.twig' %}

{% block title %}New Voiture{% endblock %}

{% block body %}
    <h1>Create new Voiture</h1>

    {{ include('voiture/_form.html.twig') }}

    <a href="{{ path('app_voiture_index') }}">back to list</a>
{% endblock %}

templates/voiture/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}Voiture{% endblock %}

{% block body %}
    <h1>Voiture</h1>

    <table class="table">
        <tbody>
            <tr>
                <th>Id</th>
                <td>{{ voiture.id }}</td>
            </tr>
            <tr>
                <th>Serie</th>
                <td>{{ voiture.serie }}</td>
            </tr>
            <tr>
                <th>Date_mise_en_marche</th>
                <td>{{ voiture.dateMiseEnMarche ? voiture.dateMiseEnMarche|date('Y-m-d') : '' }}</td>
            </tr>
            <tr>
                <th>Modele</th>
                <td>{{ voiture.modele }}</td>
            </tr>
            <tr>
                <th>Prix_jour</th>
                <td>{{ voiture.prixJour }}</td>
            </tr>
        </tbody>
    </table>

    <a href="{{ path('app_voiture_index') }}">back to list</a>

    <a href="{{ path('app_voiture_edit', {'id': voiture.id}) }}">edit</a>

    {{ include('voiture/_delete_form.html.twig') }}
{% endblock %}